<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Rcc.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler.generated</a> &gt; <span class="el_source">Rcc.java</span></div><h1>Rcc.java</h1><pre class="source lang-java linenums">/* Generated By:JavaCC: Do not edit this line. Rcc.java */
/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler.generated;

import org.apache.jute.compiler.*;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.io.File;
import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.IOException;

public class Rcc implements RccConstants {
<span class="nc" id="L32">    private static Hashtable recTab = new Hashtable();</span>
<span class="nc" id="L33">    private static String curDir = System.getProperty(&quot;user.dir&quot;);</span>
    private static String curFileName;
    private static String curModuleName;

    public static void main(String args[]) {
<span class="nc" id="L38">        String language = &quot;java&quot;;</span>
<span class="nc" id="L39">        ArrayList recFiles = new ArrayList();</span>
<span class="nc" id="L40">        JFile curFile=null;</span>

<span class="nc bnc" id="L42" title="All 2 branches missed.">        for (int i=0; i&lt;args.length; i++) {</span>
<span class="nc bnc" id="L43" title="All 2 branches missed.">            if (&quot;-l&quot;.equalsIgnoreCase(args[i]) ||</span>
<span class="nc bnc" id="L44" title="All 2 branches missed.">                &quot;--language&quot;.equalsIgnoreCase(args[i])) {</span>
<span class="nc" id="L45">                language = args[i+1].toLowerCase();</span>
<span class="nc" id="L46">                i++;</span>
            } else {
<span class="nc" id="L48">                recFiles.add(args[i]);</span>
            }
        }
<span class="nc bnc" id="L51" title="All 6 branches missed.">        if (!&quot;c++&quot;.equals(language) &amp;&amp; !&quot;java&quot;.equals(language) &amp;&amp; !&quot;c&quot;.equals(language)) {</span>
<span class="nc" id="L52">            System.out.println(&quot;Cannot recognize language:&quot; + language);</span>
<span class="nc" id="L53">            System.exit(1);</span>
        }
<span class="nc bnc" id="L55" title="All 2 branches missed.">        if (recFiles.size() == 0) {</span>
<span class="nc" id="L56">            System.out.println(&quot;No record files specified. Exiting.&quot;);</span>
<span class="nc" id="L57">            System.exit(1);</span>
        }
<span class="nc bnc" id="L59" title="All 2 branches missed.">        for (int i=0; i&lt;recFiles.size(); i++) {</span>
<span class="nc" id="L60">            curFileName = (String) recFiles.get(i);</span>
<span class="nc" id="L61">            File file = new File(curFileName);</span>
            try {
<span class="nc" id="L63">                curFile = parseFile(file);</span>
<span class="nc" id="L64">            } catch (FileNotFoundException e) {</span>
<span class="nc" id="L65">                System.out.println(&quot;File &quot; + (String) recFiles.get(i) + &quot; Not found.&quot;);</span>
<span class="nc" id="L66">                System.exit(1);</span>
<span class="nc" id="L67">            } catch (ParseException e) {</span>
<span class="nc" id="L68">                System.out.println(e.toString());</span>
<span class="nc" id="L69">                System.exit(1);</span>
<span class="nc" id="L70">            }</span>
<span class="nc" id="L71">            System.out.println((String) recFiles.get(i) + &quot; Parsed Successfully&quot;);</span>
            try {
<span class="nc" id="L73">                curFile.genCode(language, new File(&quot;.&quot;));</span>
<span class="nc" id="L74">            } catch (IOException e) {</span>
<span class="nc" id="L75">                System.out.println(e.toString());</span>
<span class="nc" id="L76">                System.exit(1);</span>
<span class="nc" id="L77">            }</span>
        }
<span class="nc" id="L79">    }</span>

    public static JFile parseFile(File file) throws FileNotFoundException, ParseException {
<span class="nc" id="L82">        curDir = file.getParent();</span>
<span class="nc" id="L83">        curFileName = file.getName();</span>
<span class="nc" id="L84">        FileReader reader = new FileReader(file);</span>
        try {
<span class="nc" id="L86">            Rcc parser = new Rcc(reader);</span>
<span class="nc" id="L87">            recTab = new Hashtable();</span>
<span class="nc" id="L88">            return parser.Input();</span>
        } finally {
<span class="nc" id="L90">            try {</span>
<span class="nc" id="L91">                reader.close();</span>
<span class="nc" id="L92">            } catch (IOException e) {</span>
<span class="nc" id="L93">            }</span>
        }
    }

  final public JFile Input() throws ParseException {
<span class="nc" id="L98">    ArrayList ilist = new ArrayList();</span>
<span class="nc" id="L99">    ArrayList rlist = new ArrayList();</span>
    JFile i;
    ArrayList l;
    label_1:
    while (true) {
<span class="nc bnc" id="L104" title="All 5 branches missed.">      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {</span>
      case INCLUDE_TKN:
<span class="nc" id="L106">        i = Include();</span>
<span class="nc" id="L107">          ilist.add(i);</span>
<span class="nc" id="L108">        break;</span>
      case MODULE_TKN:
<span class="nc" id="L110">        l = Module();</span>
<span class="nc" id="L111">          rlist.addAll(l);</span>
<span class="nc" id="L112">        break;</span>
      default:
<span class="nc" id="L114">        jj_la1[0] = jj_gen;</span>
<span class="nc" id="L115">        jj_consume_token(-1);</span>
<span class="nc" id="L116">        throw new ParseException();</span>
      }
<span class="nc bnc" id="L118" title="All 4 branches missed.">      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {</span>
      case MODULE_TKN:
      case INCLUDE_TKN:
        ;
<span class="nc" id="L122">        break;</span>
      default:
<span class="nc" id="L124">        jj_la1[1] = jj_gen;</span>
<span class="nc" id="L125">        break label_1;</span>
      }
    }
<span class="nc" id="L128">    jj_consume_token(0);</span>
<span class="nc" id="L129">      {if (true) return new JFile(curFileName, ilist, rlist);}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public JFile Include() throws ParseException {
    String fname;
    Token t;
<span class="nc" id="L136">    jj_consume_token(INCLUDE_TKN);</span>
<span class="nc" id="L137">    t = jj_consume_token(CSTRING_TKN);</span>
<span class="nc" id="L138">        JFile ret = null;</span>
<span class="nc" id="L139">        fname = t.image.replaceAll(&quot;^\&quot;&quot;, &quot;&quot;).replaceAll(&quot;\&quot;$&quot;,&quot;&quot;);</span>
<span class="nc" id="L140">        File file = new File(curDir, fname);</span>
<span class="nc" id="L141">        String tmpDir = curDir;</span>
<span class="nc" id="L142">        String tmpFile = curFileName;</span>
<span class="nc" id="L143">        curDir = file.getParent();</span>
<span class="nc" id="L144">        curFileName = file.getName();</span>
        try {
<span class="nc" id="L146">            FileReader reader = new FileReader(file);</span>
<span class="nc" id="L147">            Rcc parser = new Rcc(reader);</span>
            try {
<span class="nc" id="L149">                ret = parser.Input();</span>
<span class="nc" id="L150">                System.out.println(fname + &quot; Parsed Successfully&quot;);</span>
<span class="nc" id="L151">            } catch (ParseException e) {</span>
<span class="nc" id="L152">                System.out.println(e.toString());</span>
<span class="nc" id="L153">                System.exit(1);</span>
<span class="nc" id="L154">            }</span>
            try {
<span class="nc" id="L156">                reader.close();</span>
<span class="nc" id="L157">            } catch (IOException e) {</span>
<span class="nc" id="L158">            }</span>
<span class="nc" id="L159">        } catch (FileNotFoundException e) {</span>
<span class="nc" id="L160">            System.out.println(&quot;File &quot; + fname +</span>
                &quot; Not found.&quot;);
<span class="nc" id="L162">            System.exit(1);</span>
<span class="nc" id="L163">        }</span>
<span class="nc" id="L164">        curDir = tmpDir;</span>
<span class="nc" id="L165">        curFileName = tmpFile;</span>
<span class="nc" id="L166">        {if (true) return ret;}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public ArrayList Module() throws ParseException {
    String mName;
    ArrayList rlist;
<span class="nc" id="L173">    jj_consume_token(MODULE_TKN);</span>
<span class="nc" id="L174">    mName = ModuleName();</span>
<span class="nc" id="L175">      curModuleName = mName;</span>
<span class="nc" id="L176">    jj_consume_token(LBRACE_TKN);</span>
<span class="nc" id="L177">    rlist = RecordList();</span>
<span class="nc" id="L178">    jj_consume_token(RBRACE_TKN);</span>
<span class="nc" id="L179">      {if (true) return rlist;}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public String ModuleName() throws ParseException {
<span class="nc" id="L184">    String name = &quot;&quot;;</span>
    Token t;
<span class="nc" id="L186">    t = jj_consume_token(IDENT_TKN);</span>
<span class="nc" id="L187">      name += t.image;</span>
    label_2:
    while (true) {
<span class="nc bnc" id="L190" title="All 4 branches missed.">      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {</span>
      case DOT_TKN:
        ;
<span class="nc" id="L193">        break;</span>
      default:
<span class="nc" id="L195">        jj_la1[2] = jj_gen;</span>
<span class="nc" id="L196">        break label_2;</span>
      }
<span class="nc" id="L198">      jj_consume_token(DOT_TKN);</span>
<span class="nc" id="L199">      t = jj_consume_token(IDENT_TKN);</span>
<span class="nc" id="L200">          name += &quot;.&quot; + t.image;</span>
    }
<span class="nc" id="L202">      {if (true) return name;}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public ArrayList RecordList() throws ParseException {
<span class="nc" id="L207">    ArrayList rlist = new ArrayList();</span>
    JRecord r;
    label_3:
    while (true) {
<span class="nc" id="L211">      r = Record();</span>
<span class="nc" id="L212">          rlist.add(r);</span>
<span class="nc bnc" id="L213" title="All 4 branches missed.">      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {</span>
      case RECORD_TKN:
        ;
<span class="nc" id="L216">        break;</span>
      default:
<span class="nc" id="L218">        jj_la1[3] = jj_gen;</span>
<span class="nc" id="L219">        break label_3;</span>
      }
    }
<span class="nc" id="L222">      {if (true) return rlist;}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public JRecord Record() throws ParseException {
    String rname;
<span class="nc" id="L228">    ArrayList flist = new ArrayList();</span>
    Token t;
    JField f;
<span class="nc" id="L231">    jj_consume_token(RECORD_TKN);</span>
<span class="nc" id="L232">    t = jj_consume_token(IDENT_TKN);</span>
<span class="nc" id="L233">      rname = t.image;</span>
<span class="nc" id="L234">    jj_consume_token(LBRACE_TKN);</span>
    label_4:
    while (true) {
<span class="nc" id="L237">      f = Field();</span>
<span class="nc" id="L238">          flist.add(f);</span>
<span class="nc" id="L239">      jj_consume_token(SEMICOLON_TKN);</span>
<span class="nc bnc" id="L240" title="All 4 branches missed.">      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {</span>
      case BYTE_TKN:
      case BOOLEAN_TKN:
      case INT_TKN:
      case LONG_TKN:
      case FLOAT_TKN:
      case DOUBLE_TKN:
      case USTRING_TKN:
      case BUFFER_TKN:
      case VECTOR_TKN:
      case MAP_TKN:
      case IDENT_TKN:
        ;
<span class="nc" id="L253">        break;</span>
      default:
<span class="nc" id="L255">        jj_la1[4] = jj_gen;</span>
<span class="nc" id="L256">        break label_4;</span>
      }
    }
<span class="nc" id="L259">    jj_consume_token(RBRACE_TKN);</span>
<span class="nc" id="L260">        String fqn = curModuleName + &quot;.&quot; + rname;</span>
<span class="nc" id="L261">        JRecord r = new JRecord(fqn, flist);</span>
<span class="nc" id="L262">        recTab.put(fqn, r);</span>
<span class="nc" id="L263">        {if (true) return r;}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public JField Field() throws ParseException {
    JType jt;
    Token t;
<span class="nc" id="L270">    jt = Type();</span>
<span class="nc" id="L271">    t = jj_consume_token(IDENT_TKN);</span>
<span class="nc" id="L272">      {if (true) return new JField(jt, t.image);}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public JType Type() throws ParseException {
    JType jt;
    Token t;
    String rname;
<span class="nc bnc" id="L280" title="All 14 branches missed.">    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {</span>
    case MAP_TKN:
<span class="nc" id="L282">      jt = Map();</span>
<span class="nc" id="L283">      {if (true) return jt;}</span>
      break;
    case VECTOR_TKN:
<span class="nc" id="L286">      jt = Vector();</span>
<span class="nc" id="L287">      {if (true) return jt;}</span>
      break;
    case BYTE_TKN:
<span class="nc" id="L290">      jj_consume_token(BYTE_TKN);</span>
<span class="nc" id="L291">      {if (true) return new JByte();}</span>
      break;
    case BOOLEAN_TKN:
<span class="nc" id="L294">      jj_consume_token(BOOLEAN_TKN);</span>
<span class="nc" id="L295">      {if (true) return new JBoolean();}</span>
      break;
    case INT_TKN:
<span class="nc" id="L298">      jj_consume_token(INT_TKN);</span>
<span class="nc" id="L299">      {if (true) return new JInt();}</span>
      break;
    case LONG_TKN:
<span class="nc" id="L302">      jj_consume_token(LONG_TKN);</span>
<span class="nc" id="L303">      {if (true) return new JLong();}</span>
      break;
    case FLOAT_TKN:
<span class="nc" id="L306">      jj_consume_token(FLOAT_TKN);</span>
<span class="nc" id="L307">      {if (true) return new JFloat();}</span>
      break;
    case DOUBLE_TKN:
<span class="nc" id="L310">      jj_consume_token(DOUBLE_TKN);</span>
<span class="nc" id="L311">      {if (true) return new JDouble();}</span>
      break;
    case USTRING_TKN:
<span class="nc" id="L314">      jj_consume_token(USTRING_TKN);</span>
<span class="nc" id="L315">      {if (true) return new JString();}</span>
      break;
    case BUFFER_TKN:
<span class="nc" id="L318">      jj_consume_token(BUFFER_TKN);</span>
<span class="nc" id="L319">      {if (true) return new JBuffer();}</span>
      break;
    case IDENT_TKN:
<span class="nc" id="L322">      rname = ModuleName();</span>
<span class="nc bnc" id="L323" title="All 2 branches missed.">        if (rname.indexOf('.', 0) &lt; 0) {</span>
<span class="nc" id="L324">            rname = curModuleName + &quot;.&quot; + rname;</span>
        }
<span class="nc" id="L326">        JRecord r = (JRecord) recTab.get(rname);</span>
<span class="nc bnc" id="L327" title="All 2 branches missed.">        if (r == null) {</span>
<span class="nc" id="L328">            System.out.println(&quot;Type &quot; + rname + &quot; not known. Exiting.&quot;);</span>
<span class="nc" id="L329">            System.exit(1);</span>
        }
<span class="nc" id="L331">        {if (true) return r;}</span>
      break;
    default:
<span class="nc" id="L334">      jj_la1[5] = jj_gen;</span>
<span class="nc" id="L335">      jj_consume_token(-1);</span>
<span class="nc" id="L336">      throw new ParseException();</span>
    }
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public JMap Map() throws ParseException {
    JType jt1;
    JType jt2;
<span class="nc" id="L344">    jj_consume_token(MAP_TKN);</span>
<span class="nc" id="L345">    jj_consume_token(LT_TKN);</span>
<span class="nc" id="L346">    jt1 = Type();</span>
<span class="nc" id="L347">    jj_consume_token(COMMA_TKN);</span>
<span class="nc" id="L348">    jt2 = Type();</span>
<span class="nc" id="L349">    jj_consume_token(GT_TKN);</span>
<span class="nc" id="L350">      {if (true) return new JMap(jt1, jt2);}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  final public JVector Vector() throws ParseException {
    JType jt;
<span class="nc" id="L356">    jj_consume_token(VECTOR_TKN);</span>
<span class="nc" id="L357">    jj_consume_token(LT_TKN);</span>
<span class="nc" id="L358">    jt = Type();</span>
<span class="nc" id="L359">    jj_consume_token(GT_TKN);</span>
<span class="nc" id="L360">      {if (true) return new JVector(jt);}</span>
    throw new Error(&quot;Missing return statement in function&quot;);
  }

  public RccTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
<span class="nc" id="L369">  final private int[] jj_la1 = new int[6];</span>
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
<span class="nc" id="L373">      jj_la1_0();</span>
<span class="nc" id="L374">      jj_la1_1();</span>
<span class="nc" id="L375">   }</span>
   private static void jj_la1_0() {
<span class="nc" id="L377">      jj_la1_0 = new int[] {0x2800,0x2800,0x40000000,0x1000,0xffc000,0xffc000,};</span>
<span class="nc" id="L378">   }</span>
   private static void jj_la1_1() {
<span class="nc" id="L380">      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x1,0x1,};</span>
<span class="nc" id="L381">   }</span>

  public Rcc(java.io.InputStream stream) {
<span class="nc" id="L384">     this(stream, null);</span>
<span class="nc" id="L385">  }</span>
<span class="nc" id="L386">  public Rcc(java.io.InputStream stream, String encoding) {</span>
<span class="nc" id="L387">    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }</span>
<span class="nc" id="L388">    token_source = new RccTokenManager(jj_input_stream);</span>
<span class="nc" id="L389">    token = new Token();</span>
<span class="nc" id="L390">    jj_ntk = -1;</span>
<span class="nc" id="L391">    jj_gen = 0;</span>
<span class="nc bnc" id="L392" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) jj_la1[i] = -1;</span>
<span class="nc" id="L393">  }</span>

  public void ReInit(java.io.InputStream stream) {
<span class="nc" id="L396">     ReInit(stream, null);</span>
<span class="nc" id="L397">  }</span>
  public void ReInit(java.io.InputStream stream, String encoding) {
<span class="nc" id="L399">    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }</span>
<span class="nc" id="L400">    token_source.ReInit(jj_input_stream);</span>
<span class="nc" id="L401">    token = new Token();</span>
<span class="nc" id="L402">    jj_ntk = -1;</span>
<span class="nc" id="L403">    jj_gen = 0;</span>
<span class="nc bnc" id="L404" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) jj_la1[i] = -1;</span>
<span class="nc" id="L405">  }</span>

<span class="nc" id="L407">  public Rcc(java.io.Reader stream) {</span>
<span class="nc" id="L408">    jj_input_stream = new SimpleCharStream(stream, 1, 1);</span>
<span class="nc" id="L409">    token_source = new RccTokenManager(jj_input_stream);</span>
<span class="nc" id="L410">    token = new Token();</span>
<span class="nc" id="L411">    jj_ntk = -1;</span>
<span class="nc" id="L412">    jj_gen = 0;</span>
<span class="nc bnc" id="L413" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) jj_la1[i] = -1;</span>
<span class="nc" id="L414">  }</span>

  public void ReInit(java.io.Reader stream) {
<span class="nc" id="L417">    jj_input_stream.ReInit(stream, 1, 1);</span>
<span class="nc" id="L418">    token_source.ReInit(jj_input_stream);</span>
<span class="nc" id="L419">    token = new Token();</span>
<span class="nc" id="L420">    jj_ntk = -1;</span>
<span class="nc" id="L421">    jj_gen = 0;</span>
<span class="nc bnc" id="L422" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) jj_la1[i] = -1;</span>
<span class="nc" id="L423">  }</span>

<span class="nc" id="L425">  public Rcc(RccTokenManager tm) {</span>
<span class="nc" id="L426">    token_source = tm;</span>
<span class="nc" id="L427">    token = new Token();</span>
<span class="nc" id="L428">    jj_ntk = -1;</span>
<span class="nc" id="L429">    jj_gen = 0;</span>
<span class="nc bnc" id="L430" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) jj_la1[i] = -1;</span>
<span class="nc" id="L431">  }</span>

  public void ReInit(RccTokenManager tm) {
<span class="nc" id="L434">    token_source = tm;</span>
<span class="nc" id="L435">    token = new Token();</span>
<span class="nc" id="L436">    jj_ntk = -1;</span>
<span class="nc" id="L437">    jj_gen = 0;</span>
<span class="nc bnc" id="L438" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) jj_la1[i] = -1;</span>
<span class="nc" id="L439">  }</span>

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
<span class="nc bnc" id="L443" title="All 2 branches missed.">    if ((oldToken = token).next != null) token = token.next;</span>
<span class="nc" id="L444">    else token = token.next = token_source.getNextToken();</span>
<span class="nc" id="L445">    jj_ntk = -1;</span>
<span class="nc bnc" id="L446" title="All 2 branches missed.">    if (token.kind == kind) {</span>
<span class="nc" id="L447">      jj_gen++;</span>
<span class="nc" id="L448">      return token;</span>
    }
<span class="nc" id="L450">    token = oldToken;</span>
<span class="nc" id="L451">    jj_kind = kind;</span>
<span class="nc" id="L452">    throw generateParseException();</span>
  }

  final public Token getNextToken() {
<span class="nc bnc" id="L456" title="All 2 branches missed.">    if (token.next != null) token = token.next;</span>
<span class="nc" id="L457">    else token = token.next = token_source.getNextToken();</span>
<span class="nc" id="L458">    jj_ntk = -1;</span>
<span class="nc" id="L459">    jj_gen++;</span>
<span class="nc" id="L460">    return token;</span>
  }

  final public Token getToken(int index) {
<span class="nc" id="L464">    Token t = token;</span>
<span class="nc bnc" id="L465" title="All 2 branches missed.">    for (int i = 0; i &lt; index; i++) {</span>
<span class="nc bnc" id="L466" title="All 2 branches missed.">      if (t.next != null) t = t.next;</span>
<span class="nc" id="L467">      else t = t.next = token_source.getNextToken();</span>
    }
<span class="nc" id="L469">    return t;</span>
  }

  final private int jj_ntk() {
<span class="nc bnc" id="L473" title="All 2 branches missed.">    if ((jj_nt=token.next) == null)</span>
<span class="nc" id="L474">      return (jj_ntk = (token.next=token_source.getNextToken()).kind);</span>
    else
<span class="nc" id="L476">      return (jj_ntk = jj_nt.kind);</span>
  }

<span class="nc" id="L479">  private java.util.Vector jj_expentries = new java.util.Vector();</span>
  private int[] jj_expentry;
<span class="nc" id="L481">  private int jj_kind = -1;</span>

  public ParseException generateParseException() {
<span class="nc" id="L484">    jj_expentries.removeAllElements();</span>
<span class="nc" id="L485">    boolean[] la1tokens = new boolean[33];</span>
<span class="nc bnc" id="L486" title="All 2 branches missed.">    for (int i = 0; i &lt; 33; i++) {</span>
<span class="nc" id="L487">      la1tokens[i] = false;</span>
    }
<span class="nc bnc" id="L489" title="All 2 branches missed.">    if (jj_kind &gt;= 0) {</span>
<span class="nc" id="L490">      la1tokens[jj_kind] = true;</span>
<span class="nc" id="L491">      jj_kind = -1;</span>
    }
<span class="nc bnc" id="L493" title="All 2 branches missed.">    for (int i = 0; i &lt; 6; i++) {</span>
<span class="nc bnc" id="L494" title="All 2 branches missed.">      if (jj_la1[i] == jj_gen) {</span>
<span class="nc bnc" id="L495" title="All 2 branches missed.">        for (int j = 0; j &lt; 32; j++) {</span>
<span class="nc bnc" id="L496" title="All 2 branches missed.">          if ((jj_la1_0[i] &amp; (1&lt;&lt;j)) != 0) {</span>
<span class="nc" id="L497">            la1tokens[j] = true;</span>
          }
<span class="nc bnc" id="L499" title="All 2 branches missed.">          if ((jj_la1_1[i] &amp; (1&lt;&lt;j)) != 0) {</span>
<span class="nc" id="L500">            la1tokens[32+j] = true;</span>
          }
        }
      }
    }
<span class="nc bnc" id="L505" title="All 2 branches missed.">    for (int i = 0; i &lt; 33; i++) {</span>
<span class="nc bnc" id="L506" title="All 2 branches missed.">      if (la1tokens[i]) {</span>
<span class="nc" id="L507">        jj_expentry = new int[1];</span>
<span class="nc" id="L508">        jj_expentry[0] = i;</span>
<span class="nc" id="L509">        jj_expentries.addElement(jj_expentry);</span>
      }
    }
<span class="nc" id="L512">    int[][] exptokseq = new int[jj_expentries.size()][];</span>
<span class="nc bnc" id="L513" title="All 2 branches missed.">    for (int i = 0; i &lt; jj_expentries.size(); i++) {</span>
<span class="nc" id="L514">      exptokseq[i] = (int[])jj_expentries.elementAt(i);</span>
    }
<span class="nc" id="L516">    return new ParseException(token, exptokseq, tokenImage);</span>
  }

  final public void enable_tracing() {
<span class="nc" id="L520">  }</span>

  final public void disable_tracing() {
<span class="nc" id="L523">  }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>